-module(howdy@authentication@ets).
-compile(no_auto_import).

-export([new/2, insert/2, lookup/2, delete/2]).
-export_type([options/0, identifier_/0]).

-type options() :: set |
    ordered_set |
    bag |
    duplicate_bag |
    public |
    protected |
    private |
    named_table.

-type identifier_() :: any().

-spec new(any(), list(options())) -> identifier_().
new(A, B) ->
    ets:new(A, B).

-spec insert(any(), any()) -> boolean().
insert(A, B) ->
    ets:insert(A, B).

-spec lookup(any(), any()) -> list(any()).
lookup(A, B) ->
    ets:lookup(A, B).

-spec delete(any(), any()) -> boolean().
delete(A, B) ->
    ets:delete(A, B).
