-module(howdy@authentication@session).
-compile(no_auto_import).

-export([new/0, insert/4, lookup/1, delete/1]).
-export_type([session/0, test_session/0]).

-type session() :: session.

-type test_session() :: {test_session,
                         fun((binary(), binary(), integer(), list({binary(),
                                                                   binary()})) -> boolean()),
                         fun((binary()) -> {ok,
                                            {binary(),
                                             binary(),
                                             integer(),
                                             list({binary(), binary()})}} |
                             {error, nil}),
                         fun((binary()) -> boolean())}.

-spec new() -> howdy@authentication@ets:identifier_().
new() ->
    howdy@authentication@ets:new(session, [set, public, named_table]).

-spec insert(binary(), binary(), integer(), list({binary(), binary()})) -> boolean().
insert(Id, Name, Timeout, Claims) ->
    howdy@authentication@ets:insert(session, {Id, Name, Timeout, Claims}).

-spec lookup(binary()) -> {ok, any()} | {error, nil}.
lookup(Id) ->
    _pipe = howdy@authentication@ets:lookup(session, Id),
    gleam@list:first(_pipe).

-spec delete(binary()) -> boolean().
delete(Id) ->
    howdy@authentication@ets:delete(session, Id).
